
/*
 * 
 *  file:  ./src/edu/virginia/bioch/nopt/alignments/CumulativePosition.java
 * 
 *  Copyright (c) 2004,  the University of Virginia.
 *  All rights reverved.
 * 
 *  See the file COPYRIGHT in the top directory of this distribution for
 *  more information.
 *  
 *  THE SOFTWARE IS PROVIDED _AS IS_, WITHOUT WARRANTY OF ANY KIND, EXPRESS 
 *  OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 *  DEALINGS IN THE SOFTWARE.  
 *  
 */ 

package edu.virginia.bioch.nopt.alignments;


import java.lang.*;

public class CumulativePosition
{
	protected double cumRp;
	protected int count;

	public CumulativePosition( double f )
	{ 
		cumRp = f; 
		count = 1;
	}

	public void update( double currRp )
	{
		// weighted avg.
		count++;
		cumRp = (double)((count - 1)*cumRp + currRp) / (double)count;
	}

	public double getCumulativePosition()
	{ return cumRp; }

	public int getCount()
	{ return count; }

	public boolean equals( Object cp )
	{
		if ( this == cp )
			return true;

		if ( cp instanceof CumulativePosition )
		{
			if ( cumRp == ((CumulativePosition)cp).getCumulativePosition() &&
			 	count == ((CumulativePosition)cp).getCount() )
				return true;
			else
				return false;
		}
		else
			return false;
	}

}
